//
// CalculateScore200Response.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public enum CalculateScore200Response: Codable, JSONEncodable, Hashable {
    case typeErrorsCalculatingFoyerScore(ErrorsCalculatingFoyerScore)
    case typePropertyScore(PropertyScore)

    public func encode(to encoder: Encoder) throws {
        var container = encoder.singleValueContainer()
        switch self {
        case .typeErrorsCalculatingFoyerScore(let value):
            try container.encode(value)
        case .typePropertyScore(let value):
            try container.encode(value)
        }
    }

    public init(from decoder: Decoder) throws {
        let container = try decoder.singleValueContainer()
        if let value = try? container.decode(ErrorsCalculatingFoyerScore.self) {
            self = .typeErrorsCalculatingFoyerScore(value)
        } else if let value = try? container.decode(PropertyScore.self) {
            self = .typePropertyScore(value)
        } else {
            throw DecodingError.typeMismatch(Self.Type.self, .init(codingPath: decoder.codingPath, debugDescription: "Unable to decode instance of CalculateScore200Response"))
        }
    }
}

